diff -Naur -X diff_ignore rsync-3.0.6_base/xattrs.c rsync/xattrs.c
--- rsync-3.0.6_base/xattrs.c	2009-06-18 17:30:42.000000000 -0400
+++ rsync/xattrs.c	2019-01-14 13:38:36.000000000 -0500
@@ -859,16 +1137,25 @@
 				break;
 		}
 		if (i == xalp->count) {
+			if (strcmp(name, XATTR_FINDERINFO_NAME) == 0 && (sxp->st.st_flags & UF_HIDDEN) > 0) {
+				//fprintf(stderr, "DEBUG: not removing extraneous %s xattr from this hidden file: %s\n", name, full_fname(fname));
+				continue;
+			}
 			if (sys_lremovexattr(fname, name) < 0) {
-				rsyserr(FERROR_XFER, errno,
-					"rsync_xal_clear: lremovexattr(\"%s\",\"%s\") failed",
-					fname, name);
-				ret = -1;
+				if (errno != ENOATTR) {
+					rsyserr(FERROR_XFER, errno,
+						"rsync_xal_set: lremovexattr(%s,\"%s\") failed",
+						full_fname(fname), name);
+					ret = -1;
+				}
 			} else /* make sure caller sets mtime */
 				sxp->st.st_mtime = (time_t)-1;
 		}
 	}
 
+	// Memory leak? This should ease memory pressure, but isn't this dangerous considering that rsync_xal_l still has a reference to it?
+	rsync_xal_free(xalp);
+
 	return ret;
 }
 
@@ -891,8 +1178,13 @@
 		errno = ENOTSUP;
 		return -1;
 	}
+	
+	if (sxp->st.st_ino == 2)
+		return 1;
 
 	ndx = F_XATTR(file);
+	if (verbose)
+		fprintf(stderr, "DEBUG: set_xattr[%s]: ndx: %d | %s\n", who_am_i(), ndx, fname);
 	return rsync_xal_set(fname, lst + ndx, fnamecmp, sxp);
 }
 
@@ -909,8 +1201,8 @@
 	const char *name = is_access_acl ? XACC_ACL_ATTR : XDEF_ACL_ATTR;
 	if (sys_lsetxattr(fname, name, buf, buf_len) < 0) {
 		rsyserr(FERROR_XFER, errno,
-			"set_xattr_acl: lsetxattr(\"%s\",\"%s\") failed",
-			fname, name);
+			"set_xattr_acl: lsetxattr(%s,\"%s\") failed",
+			full_fname(fname), name);
 		return -1;
 	}
 	return 0;
@@ -953,7 +1245,7 @@
 			xst->st_gid = 0;
 			return 0;
 		}
-		rsyserr(FERROR_XFER, errno, "failed to read xattr %s for %s",
+		rsyserr(FERROR_XFER, errno, "get_stat_xattr: failed to read xattr %s for %s",
 			XSTAT_ATTR, full_fname(fname));
 		return -1;
 	}
@@ -984,13 +1276,13 @@
 		return 0;
 
 	if (read_only || list_only) {
-		rsyserr(FERROR_XFER, EROFS, "failed to write xattr %s for %s",
+		rsyserr(FERROR_XFER, EROFS, "set_stat_xattr: failed to write xattr %s for %s",
 			XSTAT_ATTR, full_fname(fname));
 		return -1;
 	}
 
 	if (x_lstat(fname, &fst, &xst) < 0) {
-		rsyserr(FERROR_XFER, errno, "failed to re-stat %s",
+		rsyserr(FERROR_XFER, errno, "set_stat_xattr: failed to re-stat %s",
 			full_fname(fname));
 		return -1;
 	}
@@ -1017,7 +1309,7 @@
 		/* xst.st_mode will be 0 if there's no current stat xattr */
 		if (xst.st_mode && sys_lremovexattr(fname, XSTAT_ATTR) < 0) {
 			rsyserr(FERROR_XFER, errno,
-				"delete of stat xattr failed for %s",
+				"set_stat_xattr: delete of stat xattr failed for %s",
 				full_fname(fname));
 			return -1;
 		}
@@ -1035,7 +1327,7 @@
 			if (errno == EPERM && S_ISLNK(fst.st_mode))
 				return 0;
 			rsyserr(FERROR_XFER, errno,
-				"failed to write xattr %s for %s",
+				"set_stat_xattr: failed to write xattr %s for %s",
 				XSTAT_ATTR, full_fname(fname));
 			return -1;
 		}
@@ -1068,4 +1360,18 @@
 	return ret;
 }
 
+int64 xattr_size(struct file_struct *file)
+{
+	int64 xattrSize = 0;
+	item_list *lst = rsync_xal_l.items;
+	int cnt;
+	rsync_xa *rxa;
+
+	lst += F_XATTR(file);
+	for (rxa = lst->items, cnt = lst->count; cnt--; rxa++)
+		xattrSize += rxa->datum_len;
+
+	return xattrSize;
+}
+
 #endif /* SUPPORT_XATTRS */
